pub mod client;
pub mod user;
use thiserror::Error;
#[derive(Error, Debug)]
pub enum Error {
    #[error("Couldn't authenticate")]
    NotAuthenticated(String),
}
#[cfg(test)]
mod tests {
    use super::client::*;
    use std::env;
    extern crate dotenv;
    use crate::user::UserMethods;
    use std::mem::size_of;
    use crate::user::User;
    #[actix_rt::test]
    async fn it_works() {
        assert_eq!(2 + 2, 4);
        dotenv::dotenv().expect("Failed to load .env file");
        let client_id = env::var("OSU_ID").expect("Expected a token in the environment");
        let client_secret = env::var("OSU_SECRET").expect("Expected a token in the environment");
        let mut client = Client::new(client_id, client_secret).await.unwrap();
        let users = client.search_user("beetroot".to_string()).await.unwrap();
        let user = client
            .get_user(users.user.data[0].id, "osu".to_string())
            .await
            .unwrap();
        println!("{:?}", client);
        println!("{:?}", users.user.data[0]);
        println!("{:?}", user);
        println!("{}", size_of::<User>())
    }
}
